Index: NEMO/trunk/cfgs/AGRIF_DEMO/EXPREF/1_namelist_cfg
===================================================================
--- NEMO/trunk/cfgs/AGRIF_DEMO/EXPREF/1_namelist_cfg	(revision 12984)
+++ NEMO/trunk/cfgs/AGRIF_DEMO/EXPREF/1_namelist_cfg	(revision 12994)
@@ -81,6 +81,7 @@
    ln_blk      = .true.    !  Bulk formulation                          (T => fill namsbc_blk )
                      ! Sea-ice :
-   nn_ice      = 2         !  =2 or 3 automatically for SI3 or CICE    ("key_si3" or "key_cice")
-                           !          except in AGRIF zoom where it has to be specified
+   nn_ice      = 2         !  =0 no ice boundary condition
+      !                    !  =1 use observed ice-cover                 (  => fill namsbc_iif )
+      !                    !  =2 or 3 for SI3 and CICE, respectively
                      ! Misc. options of sbc : 
    ln_traqsr   = .true.    !  Light penetration in the ocean            (T => fill namtra_qsr)
Index: NEMO/trunk/cfgs/AGRIF_DEMO/EXPREF/2_namelist_cfg
===================================================================
--- NEMO/trunk/cfgs/AGRIF_DEMO/EXPREF/2_namelist_cfg	(revision 12984)
+++ NEMO/trunk/cfgs/AGRIF_DEMO/EXPREF/2_namelist_cfg	(revision 12994)
@@ -78,5 +78,7 @@
    ln_blk      = .true.    !  Bulk formulation                          (T => fill namsbc_blk )
                      ! Sea-ice :
-   nn_ice      = 2         !  =0   Use SI3 model
+   nn_ice      = 2         !  =0 no ice boundary condition
+      !                    !  =1 use observed ice-cover                 (  => fill namsbc_iif )
+      !                    !  =2 or 3 for SI3 and CICE, respectively
                      ! Misc. options of sbc : 
    ln_traqsr   = .true.    !  Light penetration in the ocean            (T => fill namtra_qsr)
Index: NEMO/trunk/cfgs/AGRIF_DEMO/EXPREF/3_namelist_cfg
===================================================================
--- NEMO/trunk/cfgs/AGRIF_DEMO/EXPREF/3_namelist_cfg	(revision 12984)
+++ NEMO/trunk/cfgs/AGRIF_DEMO/EXPREF/3_namelist_cfg	(revision 12994)
@@ -78,5 +78,7 @@
    ln_blk      = .true.    !  Bulk formulation                          (T => fill namsbc_blk )
                      ! Sea-ice :
-   nn_ice      = 2         !  =0   Use SI3 model
+   nn_ice      = 2         !  =0 no ice boundary condition
+      !                    !  =1 use observed ice-cover                 (  => fill namsbc_iif )
+      !                    !  =2 or 3 for SI3 and CICE, respectively
                      ! Misc. options of sbc : 
    ln_traqsr   = .true.    !  Light penetration in the ocean            (T => fill namtra_qsr)
Index: NEMO/trunk/cfgs/AGRIF_DEMO/EXPREF/namelist_cfg
===================================================================
--- NEMO/trunk/cfgs/AGRIF_DEMO/EXPREF/namelist_cfg	(revision 12984)
+++ NEMO/trunk/cfgs/AGRIF_DEMO/EXPREF/namelist_cfg	(revision 12994)
@@ -81,6 +81,7 @@
    ln_blk      = .true.    !  Bulk formulation                          (T => fill namsbc_blk )
                      ! Sea-ice :
-   nn_ice      = 2         !  =2 or 3 automatically for SI3 or CICE    ("key_si3" or "key_cice")
-                           !          except in AGRIF zoom where it has to be specified
+   nn_ice      = 2         !  =0 no ice boundary condition
+      !                    !  =1 use observed ice-cover                 (  => fill namsbc_iif )
+      !                    !  =2 or 3 for SI3 and CICE, respectively
                      ! Misc. options of sbc : 
    ln_traqsr   = .true.    !  Light penetration in the ocean            (T => fill namtra_qsr)
Index: NEMO/trunk/cfgs/ORCA2_ICE_ABL/EXPREF/namelist_cfg
===================================================================
--- NEMO/trunk/cfgs/ORCA2_ICE_ABL/EXPREF/namelist_cfg	(revision 12984)
+++ NEMO/trunk/cfgs/ORCA2_ICE_ABL/EXPREF/namelist_cfg	(revision 12994)
@@ -84,6 +84,7 @@
    ln_abl      = .true.    !  ABL  formulation                          (T => fill namsbc_abl )
                      ! Sea-ice :
-   nn_ice      = 2         !  =2 or 3 automatically for SI3 or CICE    ("key_si3" or "key_cice")
-                           !          except in AGRIF zoom where it has to be specified
+   nn_ice      = 2         !  =0 no ice boundary condition
+      !                    !  =1 use observed ice-cover                 (  => fill namsbc_iif )
+      !                    !  =2 or 3 for SI3 and CICE, respectively
                      ! Misc. options of sbc : 
    ln_traqsr   = .true.    !  Light penetration in the ocean            (T => fill namtra_qsr)
Index: NEMO/trunk/cfgs/ORCA2_ICE_PISCES/EXPREF/namelist_cfg
===================================================================
--- NEMO/trunk/cfgs/ORCA2_ICE_PISCES/EXPREF/namelist_cfg	(revision 12984)
+++ NEMO/trunk/cfgs/ORCA2_ICE_PISCES/EXPREF/namelist_cfg	(revision 12994)
@@ -80,6 +80,7 @@
    ln_blk      = .true.    !  Bulk formulation                          (T => fill namsbc_blk )
                      ! Sea-ice :
-   nn_ice      = 2         !  =2 or 3 automatically for SI3 or CICE    ("key_si3" or "key_cice")
-                           !          except in AGRIF zoom where it has to be specified
+   nn_ice      = 2         !  =0 no ice boundary condition
+      !                    !  =1 use observed ice-cover                 (  => fill namsbc_iif )
+      !                    !  =2 or 3 for SI3 and CICE, respectively
                      ! Misc. options of sbc : 
    ln_traqsr   = .true.    !  Light penetration in the ocean            (T => fill namtra_qsr)
Index: NEMO/trunk/cfgs/ORCA2_SAS_ICE/EXPREF/namelist_cfg
===================================================================
--- NEMO/trunk/cfgs/ORCA2_SAS_ICE/EXPREF/namelist_cfg	(revision 12984)
+++ NEMO/trunk/cfgs/ORCA2_SAS_ICE/EXPREF/namelist_cfg	(revision 12994)
@@ -59,5 +59,7 @@
    nn_fsbc     = 1         !  frequency of SBC module call
    ln_blk      = .true.    !  Bulk formulation                          (T => fill namsbc_blk )
-   nn_ice      = 2         !  =2  sea-ice model                         ("key_SI3" or "key_cice")
+   nn_ice      = 2         !  =0 no ice boundary condition
+      !                    !  =1 use observed ice-cover                 (  => fill namsbc_iif )
+      !                    !  =2 or 3 for SI3 and CICE, respectively
 /
 !-----------------------------------------------------------------------
Index: NEMO/trunk/cfgs/WED025/EXPREF/namelist_cfg
===================================================================
--- NEMO/trunk/cfgs/WED025/EXPREF/namelist_cfg	(revision 12984)
+++ NEMO/trunk/cfgs/WED025/EXPREF/namelist_cfg	(revision 12994)
@@ -116,8 +116,7 @@
    ln_blk      = .true.    !  Bulk formulation                          (T => fill namsbc_blk )
                      ! Sea-ice :
-   nn_ice      = 2         !  =0 no ice boundary condition    
+   nn_ice      = 2         !  =0 no ice boundary condition
       !                    !  =1 use observed ice-cover                 (  => fill namsbc_iif )
-      !                    !  =2 or 3 automatically for SI3 or CICE    ("key_si3" or "key_cice")
-      !                    !          except in AGRIF zoom where it has to be specified
+      !                    !  =2 or 3 for SI3 and CICE, respectively
    ln_ice_embd = .false.   !  =T embedded sea-ice (pressure + mass and salt exchanges)
       !                    !  =F levitating ice (no pressure, mass and salt exchanges)
Index: NEMO/trunk/src/OCE/SBC/sbcmod.F90
===================================================================
--- NEMO/trunk/src/OCE/SBC/sbcmod.F90	(revision 12984)
+++ NEMO/trunk/src/OCE/SBC/sbcmod.F90	(revision 12994)
@@ -120,15 +120,4 @@
       ncom_fsbc = nn_fsbc    ! make nn_fsbc available for lib_mpp
 #endif
-      !                             !* overwrite namelist parameter using CPP key information
-#if defined key_agrif
-      IF( Agrif_Root() ) THEN                ! AGRIF zoom (cf r1242: possibility to run without ice in fine grid)
-         IF( lk_si3  )   nn_ice      = 2
-         IF( lk_cice )   nn_ice      = 3
-      ENDIF
-!!GS: TBD
-!#else
-!      IF( lk_si3  )   nn_ice      = 2
-!      IF( lk_cice )   nn_ice      = 3
-#endif
       !
       IF(lwp) THEN                  !* Control print